#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "calculator.h"

int main() {
    char input[256];
    scanf("%s", input);
    int32_t infix_expression_length = strlen(input);
    char **infix_expression = (char **)malloc(sizeof(char *) * infix_expression_length);

    for (int32_t i = 0; i < infix_expression_length; i += 1) {
        infix_expression[i] = (char *)malloc(sizeof(char) * 100);
        char tmp[100];
        tmp[0] = input[i];
        strcpy(infix_expression[i], tmp);
    }

    // for (int32_t i = 0; i < infix_expression_length; i += 1) {
    //     printf("%s ", infix_expression[i]);
    // }
    // printf("\n");

    int32_t postfix_expression_length;
    char **postfix_expression = infix_to_postfix(infix_expression, infix_expression_length, &postfix_expression_length);

    for (int32_t i = 0; i < infix_expression_length; i += 1) {
        free(infix_expression[i]);
    }
    free(infix_expression);

    // for (int32_t i = 0; i < postfix_expression_length; i += 1) {
    //     printf("%s ", postfix_expression[i]);
    // }
    // printf("\n");

    double result = parse_postfix_epxression(postfix_expression, postfix_expression_length);
    printf("%.15lf\n", result);

    for (int32_t i = 0; i < postfix_expression_length; i += 1) {
        free(postfix_expression[i]);
    }
    free(postfix_expression);

    return EXIT_SUCCESS;
}
