#ifndef STACK_HEADER
#define STACK_HEADER

#include <stdbool.h>
#include <stdint.h>

typedef struct Stack {
    int32_t size;
    int32_t top;
    char **data;
} Stack;

void stack_init(Stack *s, int32_t size);
bool stack_is_empty(Stack *s);
void stack_push(Stack *s, char *value);
void stack_pop(Stack *s, char *value);
void stack_peek(Stack *s, char *value);
void stack_destroy(Stack *s);

#endif
